set linesize 2000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
column c new_value cs noprint;
 
select name n from v$database;
select user u from dual;
SELECT SYS_CONTEXT('USERENV', 'CON_NAME') c FROM DUAL;

set sqlprompt &ns:&cs:&us>

set head on
set echo on
set termout on
set trimspool on

spool &ns..&cs..online12c1.log

-- run on exadata
-- do an online compress of table for query high

select * from v$version;

drop table test;

create table test as select * from dba_tables;

ALTER TABLE TEST 
ADD CONSTRAINT PK_TEST 
PRIMARY KEY (OWNER,TABLE_NAME);

select COMPRESSION,COMPRESS_FOR
from user_tables where table_name='TEST';

select bytes from user_segments
where segment_name='TEST' and
segment_type='TABLE';

select table_name,column_name
from USER_TAB_COLS
where table_name='TEST'
order by column_id;

BEGIN
  DBMS_REDEFINITION.REDEF_TABLE(
    uname                      => user,
    tname                      => 'TEST',
    table_compression_type     => 'COMPRESS');
END;
/ 

select COMPRESSION,COMPRESS_FOR
from user_tables where table_name='TEST';

select bytes from user_segments
where segment_name='TEST' and
segment_type='TABLE';

column table_name format a30
column column_name format a30

select table_name,column_name
from USER_TAB_COLS
where table_name='TEST'
order by column_id;

spool off
