set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
column c new_value cs noprint;
 
select name n from v$database;
select user u from dual;
SELECT SYS_CONTEXT('USERENV', 'CON_NAME') c FROM DUAL;

set sqlprompt &ns:&cs:&us>

set head on
set echo on
set termout on
set trimspool on
set timing on

spool &ns..&cs..online12c2.log

-- run on exadata
-- do an online compress of table for query high

select * from v$version;

drop table test;

-- table starts compressed

create table test compress as select * from dba_tables;

-- simulate update of a new column

update test set blocks=0;

commit;

select COMPRESSION,COMPRESS_FOR
from user_tables where table_name='TEST';

select bytes from user_segments
where segment_name='TEST' and
segment_type='TABLE';

drop table inttest;

create table inttest compress as select * from test where 1=2;

BEGIN
DBMS_REDEFINITION.CAN_REDEF_TABLE (
    uname                      => 'ZBL6050',
    tname                      => 'TEST',
    options_flag               => dbms_redefinition.cons_use_rowid);
END;
/ 

BEGIN
DBMS_REDEFINITION.START_REDEF_TABLE (
    uname                      => 'ZBL6050',
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST',
    options_flag               => dbms_redefinition.cons_use_rowid);
END;
/ 

select count(*) from test;
select count(*) from inttest;

BEGIN
DBMS_REDEFINITION.FINISH_REDEF_TABLE (
    uname                      => 'ZBL6050',
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST');
END;
/ 

select COMPRESSION,COMPRESS_FOR
from user_tables where table_name='TEST';

select bytes from user_segments
where segment_name='TEST' and
segment_type='TABLE';

select table_name,column_name
from USER_TAB_COLS
where table_name='TEST'
and HIDDEN_COLUMN='YES'
order by column_id;

ALTER TABLE TEST DROP UNUSED COLUMNS;

select table_name,column_name
from USER_TAB_COLS
where table_name='TEST'
and HIDDEN_COLUMN='YES'
order by column_id;

spool off
