set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
column c new_value cs noprint;
 
select name n from v$database;
select user u from dual;
SELECT SYS_CONTEXT('USERENV', 'CON_NAME') c FROM DUAL;

set sqlprompt &ns:&cs:&us>

set head on
set echo on
set termout on
set trimspool on
set timing on

spool &ns..&cs..online12c5.log

-- copy pk and index
-- register index manually

drop table test;
drop table inttest;

create table test as select * from dba_tables;

ALTER TABLE TEST 
ADD CONSTRAINT PK_TEST 
PRIMARY KEY (OWNER,TABLE_NAME);

create index testi on test(tablespace_name);

select index_name from user_indexes where table_name='TEST';

column CONSTRAINT_NAME format a30

select CONSTRAINT_NAME,constraint_type from user_constraints where table_name='TEST';

column column_name format a30

select column_name from user_ind_columns
where index_name='TESTI'
order by COLUMN_POSITION;

create table inttest as select * from test where 1=2;

create index inttesti on inttest(tablespace_name,owner);

BEGIN
DBMS_REDEFINITION.CAN_REDEF_TABLE (
    uname                      => user,
    tname                      => 'TEST');
END;
/ 

BEGIN
DBMS_REDEFINITION.START_REDEF_TABLE (
    uname                      => user,
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST');
END;
/ 

BEGIN
 DBMS_REDEFINITION.REGISTER_DEPENDENT_OBJECT(
   uname         => user,
   orig_table    => 'TEST',
   int_table     => 'INTTEST',
   dep_type      => DBMS_REDEFINITION.CONS_INDEX,
   dep_owner     => user,
   dep_orig_name => 'TESTI',
   dep_int_name  => 'INTTESTI');
END;
/

DECLARE
errcount PLS_INTEGER;
BEGIN
DBMS_REDEFINITION.COPY_TABLE_DEPENDENTS (
    uname                      => user,
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST',
    ignore_errors              => TRUE,
    num_errors                 => errcount
);
dbms_output.put_line('error count = '||errcount);
END;
/ 

BEGIN
DBMS_REDEFINITION.FINISH_REDEF_TABLE (
    uname                      => user,
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST');
END;
/ 

select index_name from user_indexes where table_name='TEST';

select CONSTRAINT_NAME,constraint_type from user_constraints where table_name='TEST';

select column_name from user_ind_columns
where index_name='TESTI'
order by COLUMN_POSITION;

spool off
