set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
column x new_value cs noprint;
 
select name n from v$database;
select user u from dual;
SELECT SYS_CONTEXT('USERENV', 'CON_NAME') x FROM DUAL;

set sqlprompt &ns:&xs:&us>

set head on
set echo on
set termout on
set trimspool on
set timing on

spool &ns..&cs..online12c6.log

-- column change

drop table test;
drop table inttest;

create table test (A number, B number, C NUMber);

ALTER TABLE TEST 
ADD CONSTRAINT PK_TEST 
PRIMARY KEY (A);

insert into test values (1,2,3);

commit;

select * from test;

create table inttest (A number, C number, B varchar2(10));

BEGIN
DBMS_REDEFINITION.CAN_REDEF_TABLE (
    uname                      => user,
    tname                      => 'TEST');
END;
/ 

BEGIN
DBMS_REDEFINITION.START_REDEF_TABLE (
    uname                      => user,
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST',
    col_mapping                => 'A A,C C,to_char(B) B');
END;
/ 

DECLARE
errcount PLS_INTEGER;
BEGIN
DBMS_REDEFINITION.COPY_TABLE_DEPENDENTS (
    uname                      => user,
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST',
    ignore_errors              => TRUE,
    num_errors                 => errcount
);
dbms_output.put_line('error count = '||errcount);
END;
/ 

BEGIN
DBMS_REDEFINITION.FINISH_REDEF_TABLE (
    uname                      => user,
    orig_table                 => 'TEST',
    int_table                  => 'INTTEST');
END;
/

select * from test;

set linesize 80

desc test

spool off
